/* 
   Author: Sergio Porcu

*/

#include <stdio.h>
#include <math.h>

double potenzaIte (double x, int n);
double potenzaRic (double x, int n);

main (void)
{
  float x;
  double y;
  int n;
 
  fprintf (stdout, "Base x: ");
  scanf ("%f", &x);
  fprintf (stdout, "Exponent n: ");
  scanf ("%d", &n);

  fprintf (stdout, "Function (%f^%d) = %f\n", x, n, pow (x, n));

/* computing power by iteration */
  y = potenzaIte (x, n);
  fprintf (stdout, "Iterating (%f^%d) = %f\n", x, n, y);

/* computing power by recursion */
  y = potenzaRic (x, n);
  fprintf (stdout, "Recursive (%f^%d) = %f\n", x, n, y);

  return;
}

double
potenzaIte (
  double x,
  int n
  )
{
  double pot;
  int i;

  pot = 1.0;
  for (i=1; i<=n; i++) {
    pot = pot * x;
  }

  return (pot);
}

double
potenzaRic (
  double x,
  int n
  )
{
  if (n==0) {
    return (1.0);
  }

  if (n==1) {
    return (x);
  }

  return (x * potenzaRic (x, n-1));
}



