/* 
   Author: Sergio Porcu
*/

#include <stdlib.h>
#include <stdio.h>

#define L 50
#define NDIGIT 3

#define PARENT(i)	((i-1) / 2)
#define LEFT(i)   ((i*2) + 1)
#define RIGHT(i)	((i*2) + 2)

void HeapSort(int A[], int n, FILE *fpU);

main ()
{
  FILE *fpI, *fpU;
  char nomeFileI[L], nomeFileU[L];
  int i, j, n, vetvar, *vet;

  fprintf (stdout, "Input filename: ");
  scanf ("%s", nomeFileI);
  fprintf (stdout, "Output filename: ");
  scanf ("%s", nomeFileU);

  fpI = fopen (nomeFileI, "r");
  fpU = fopen (nomeFileU, "w");
  if (fpI == NULL || fpU == NULL) {
	 fprintf (stderr, "Error while opening file.\n");
	 exit (1);
  }

  fscanf (fpI, "%d", &n);
  vet = (int *) malloc (n * sizeof (int));
  if (vet == NULL) {
	 fprintf (stderr, "Error while allocating vector.\n");
	 exit (1);
  }

  i = 0;
  while (fscanf (fpI, "%3d", &vet[i]) != EOF ) {
	 i++;
  }

  fprintf (fpU, "\n");
  fprintf (fpU, "INPUT : ");
  for (i=0; i<n; i++) {
	 fprintf (fpU, "%3d ", vet[i]);
	 }
  fprintf (fpU, "\n\n");

  HeapSort (vet, n, fpU);

  fprintf (fpU, "\n");
  fprintf (fpU, "RESULT  : ");
  for (i=0; i<n; i++) {
	 fprintf (fpU, "%3d ", vet[i]);
  }
  fprintf (fpU, "\n");

  fclose (fpI);
  fclose (fpU);

  return;
}

void Swap( int v[], int n1, int n2)
{
	int	temp;
	temp  = v[n1];
	v[n1] = v[n2];
	v[n2] = temp;
}

void Heapify(int v[], int i, int heapsize)
{
	int l, r, largest;

	l = LEFT(i);
	r = RIGHT(i);

	if (l< heapsize && v[l]>v[i]) {
		largest = l;
	} else {
		largest = i;
	}
	if (r<heapsize && v[r]>v[largest]) {
		largest = r;
	}
	if (largest != i) {
		Swap(v,i,largest);
		Heapify(v,largest,heapsize);
	}
}

void BuildHeap (int v[], int heapsize)
{
	int i;
	for (i=(heapsize)/2-1; i >= 0; i--) {
		Heapify(v,i,heapsize);
	}
	return;
}


void HeapSort( int v[], int dim, FILE *fpU)
{
	int i, k,
	heap_size = dim;
	BuildHeap(v, heap_size);
	fprintf (fpU, "IN HEAP  : ");
	for (i=0; i<dim; i++) {
	  fprintf (fpU, "%3d ", v[i]);
	}
	fprintf (fpU, "\n\n");



	for (i=dim-1; i > 0; i--) {
		fprintf (fpU, "LOOP %3d: ", dim-i);
		for (k=0; k<=i; k++) {
		  fprintf (fpU, "%3d ", v[k]);
		}
		fprintf (fpU, " -  ");
		for (k=i+1; k<dim; k++) {
		  fprintf (fpU, "%3d ", v[k]);
		}

		fprintf (fpU, "\n");
		Swap (v,0,i);
		heap_size--;
		Heapify(v,0,heap_size);
	}
}

