/* 
   Author: Sergio Porcu
*/

#include <stdlib.h>
#include <stdio.h>

#define L 50

void MergeSort (int A[], int p, int r, int n, FILE *fpU);
void Merge (int A[], int p, int q, int r);

main ()
{
  FILE *fpI, *fpU;
  char nomeFileI[L], nomeFileU[L];
  int i, j, n, vetvar, *vet;


  fprintf (stdout, "Input filename: ");
  scanf ("%s", nomeFileI);
  fprintf (stdout, "Output filename: ");
  scanf ("%s", nomeFileU);


  fpI = fopen (nomeFileI, "r");
  fpU = fopen (nomeFileU, "w");
  if (fpI == NULL || fpU == NULL) {
	 fprintf (stderr, "Error while opening file.\n");
	 exit (1);
  }


  fscanf (fpI, "%d", &n);
  vet = (int *) malloc (n * sizeof (int));
  if (vet == NULL) {
	 fprintf (stderr, "Error while allocating vector.\n");
	 exit (1);
  }


  i = 0;
  while (fscanf (fpI, "%3d", &vet[i]) != EOF ) {
	 i++;
  }


  fprintf (fpU, "\n");
  fprintf (fpU, "INPUT   : ");
  for (i=0; i<n; i++) {
	 fprintf (fpU, "%3d ", vet[i]);
	 }
  fprintf (fpU, "\n\n");


/* Calling sorting function */ 
  MergeSort (vet, 0, n-1, n, fpU);


  fprintf (fpU, "\n");
  fprintf (fpU, "RESULT     : ");
  for (i=0; i<n; i++) {
	 fprintf (fpU, "%3d ", vet[i]);
  }
  fprintf (fpU, "\n");

  fclose (fpI);
  fclose (fpU);

  return;
}

void MergeSort (
	int A[],
	int p,
	int r,
	int n,
	FILE *fpU
	)
{
	if (p<r) {

		int q=(p+r)/2;
		int i;
		fprintf (fpU, "PARTITION : ");
		for (i=0; i<p;  i++) {
			fprintf (fpU, "    ");
		}
		for (i=p; i<=r; i++) {
			fprintf (fpU, "%3d ", A[i]);
		}
		fprintf (fpU, "\n");
		MergeSort (A, p, q, n, fpU);
		MergeSort (A, q+1, r, n, fpU);
		Merge (A, p, q+1, r);
		fprintf (fpU, "MERGING    : ");
		for (i=0; i<p;  i++) {
			fprintf (fpU, "    ");
		}
		for (i=p; i<=r; i++) {
			fprintf (fpU, "%3d ", A[i]);
		}
		fprintf (fpU, "\n");
	}
	return;
}

void Merge (
	int A[],
	int p,
	int q,
	int r
	)
{
	int *tmpvet=(int*)malloc((r-p+1)*sizeof(int));
	int i=p;
	int j=q;
	int k=0;

	if (tmpvet == NULL) {
	  fprintf (stderr, "Error while allocating temporary vector.\n");
	  exit (1);
	}
	while ((i<q)&&(j<=r))
		if (A[i]<A[j])
			tmpvet[k++]=A[i++];
		else
			tmpvet[k++]=A[j++];
	while (i<q)
		tmpvet[k++]=A[i++];
	while (j<=r)
		tmpvet[k++]=A[j++];
	for (k=0;k<r-p+1;k++)
		A[p+k]=tmpvet[k];
	return;
}


