/* 
   Author: Sergio Porcu

*/

#include <stdlib.h>
#include <stdio.h>

#define L 50

void Quicksort(int v[], int left, int right,	int n, FILE *fpU);
void swap(int vet[], int i, int j);

main ()
{
  FILE *fpI, *fpU;
  char nomeFileI[L], nomeFileU[L];
  int i, j, n, vetvar, *vet;


  fprintf (stdout, "Input filename: ");
  scanf ("%s", nomeFileI);
  fprintf (stdout, "Output filename: ");
  scanf ("%s", nomeFileU);


  fpI = fopen (nomeFileI, "r");
  fpU = fopen (nomeFileU, "w");
  if (fpI == NULL || fpU == NULL) {
	 fprintf (stderr, "Error while opening file.\n");
	 exit (1);
  }


  fscanf (fpI, "%d", &n);
  vet = (int *) malloc (n * sizeof (int));
  if (vet == NULL) {
	 fprintf (stderr, "Error while allocating vector.\n");
	 exit (1);
  }


  i = 0;
  while (fscanf (fpI, "%3d", &vet[i]) != EOF ) {
	 i++;
  }


  fprintf (fpU, "\n");
  fprintf (fpU, "INPUT : ");
  for (i=0; i<n; i++) {
	 fprintf (fpU, "%3d ", vet[i]);
	 }
  fprintf (fpU, "\n\n");

  /* Vector sorting */

  fprintf (fpU,
	"Symbols: x = Pivot element, used to split the partitions\n"
	"         i = Left index\n"
	"         j = Right index (also used to split the partitions)\n\n"
  );

  Quicksort(vet, 0, n-1, n, fpU);


  fprintf (fpU, "\n");
  fprintf (fpU, "RESULT   : ");
  for (i=0; i<n; i++) {
	 fprintf (fpU, "%3d ", vet[i]);
  }
  fprintf (fpU, "\n");

  fclose (fpI);
  fclose (fpU);

  return;
}


void Quicksort(   /* Sorting function */
	int v[],       /* Vector that must be sorted */
	int p,         /* First element of vector v */
	int r,         /* Last element of vector v */
	int n,         /* Number of elements in vector v (used for debug) */
	FILE *fpU      /* File where temporary results are written to */
	)
{
	int	i, j, x, k;

	if (p >= r)
	  return;

	x = v[p];
	i = p-1; j = r+1;

	while (i<j) {
	 while (v[--j] > x);
	 while (v[++i] < x);
		fprintf (fpU, "p=%3d r=%3d: ", p, r);
		for (k=0; k<p; k++)
			fprintf (fpU, "      ");
		for (k=p; k<=r; k++) {
			char riemp=3; /* Riempitivo */
			fprintf (fpU, "%3d", v[k]);
			if (k==p) {
			  fprintf (fpU, "x", v[k]);
			  riemp--;
			}
			if (k==i) {
			  fprintf (fpU, "i", v[k]);
			  riemp--;
			}
			if (k==j) {
			  fprintf (fpU, "j", v[k]);
			  riemp--;
			}
			while (riemp--) fprintf (fpU, " ");
		}
		fprintf (fpU, "\n");

	 if (i<j) {
		swap (v, i, j);
	 }
	}
	Quicksort (v, p, j, n, fpU);
	Quicksort (v, j+1, r, n, fpU);

}

void swap(	/* Swaps element i with element j in vector vet */
	int vet[],
	int i,
	int j
	)
{
	int tmp=vet[i];
	vet[i]=vet[j];
	vet[j]=tmp;
}
