/* 
   Author: Sergio Porcu
   
Knight's Tour
A Knight (from Chess), which can move only in
a L shape, must visit all the squares of a chessboard,
visiting each square once only. This code solves the
problem via recursion.

*/


#include <stdio.h>

#define DIM 8
#define KO 0
#define OK 1

int muovi (int, int, int, int [], int [], int [][DIM]);

int
main (
  )
{
  int offsetX[8], offsetY[8], scacc[DIM][DIM];
  int i, j, result;

  offsetX[0] =  2; offsetY[0] =  1;
  offsetX[1] =  1; offsetY[1] =  2;
  offsetX[2] = -1; offsetY[2] =  2;
  offsetX[3] = -2; offsetY[3] =  1;
  offsetX[4] = -2; offsetY[4] = -1;
  offsetX[5] = -1; offsetY[5] = -2;
  offsetX[6] =  1; offsetY[6] = -2;
  offsetX[7] =  2; offsetY[7] = -1;

  for (i=0; i<DIM; i++) {
    for (j=0; j<DIM; j++) {
      scacc[i][j] = 0;
    }
  }

  scacc[0][0] = 1;
  result = muovi(2, 0, 0, offsetX, offsetY, scacc);   
  if (result == OK) {
    for (i=0; i<DIM; i++) {
      for (j=0; j<DIM; j++) {
        fprintf (stdout, "%2d ", scacc[i][j]);
      }
      fprintf (stdout, "\n");
    }

    return (OK);
  } else {
    fprintf (stdout, "Soluzion not found\n");
    return (KO);
  }
}

int
muovi (
  int mossa,
  int posx,
  int posy,
  int offsetX[],
  int offsetY[],
  int scacc[][DIM]
  )
{
  int i, ret, newposx, newposy;

  if (mossa == (DIM*DIM+1)) {
    return (OK);
  }

  for (i=0; i<8; i++) {
    newposx = posx + offsetX[i];
    newposy = posy + offsetY[i];
    if ((newposx<DIM) && (newposx>=0) && (newposy<DIM) && (newposy>=0)) {
      if (scacc[newposx][newposy] == 0) {
        scacc[newposx][newposy] = mossa;
        ret = muovi(mossa+1, newposx, newposy, offsetX, offsetY, scacc);
        if (ret == 0) {
          scacc[newposx][newposy] = 0;
        } else {
          return (OK);
        }
      }
    }
  }

  return (KO);
}
