/* 
   Author: Sergio Porcu
   
This code generates ALL the possibile anagrams for a given word, via
recursion, including duplicates. E.g., for the word aab we'll have:
aab, aab, aba, aba, baa, baa.
*/

#include <stdio.h>

#define MAX_L 10

void genAna (char *, int *, int, int);
void visAna (char *, int *, int);

main ()
{
  char parola[MAX_L];
  int usato[MAX_L];
  int l, i;

  fprintf (stdout, "Insert a word: ");
  scanf ("%s", parola);

  l = strlen (parola);

  for (i=0; i<l; i++) {
    usato[i] = (-1);
  }

  fprintf (stdout, "Anagrams:\n");
  genAna (parola, usato, l, 0);
}

void
genAna (
  char *parola,
  int *usato,
  int l,
  int level
  )
{
  int i;

  if (level == l) {
    visAna (parola, usato, l);
    return;
  }

  for (i=0; i<l; i++) {
    if (usato[i]==(-1)) {
      usato[i] = level;
      genAna (parola, usato, l, level+1);
      usato[i] = (-1);
    }
  }

  return;
}

void
visAna (
  char *parola,
  int *usato,
  int l
  )
{
  static numeroAnagramma = 1;
  int i, j;

  fprintf (stdout, "%d ", numeroAnagramma);
  numeroAnagramma++;

  for (i=0; i<l; i++) {
    for (j=0; j<l; j++) {
      if (usato[j]==i) {
        fprintf (stdout, "%c", parola[j]);
        break;
      }
    }
  }
  
  fprintf (stdout, "\n");
  return;
}
