/*
This code generates ALL the possibile anagrams for a given word, via
recursion, including duplicates. E.g., for the word aab we'll have:
aab, aab, aba, aba, baa, baa.
 */

#include <stdio.h>

#define MAX_L 10

void genAna (int *, char *, int, int);
int stat (char *, int *);

main ()
{
  int  len;
  char word[MAX_L];
  char anag[MAX_L];
  int  freq[256];

  fprintf (stdout, "Insert a word: ");
  scanf ("%s", word);
  len = stat (word, freq);

  fprintf (stdout, "Anagrams:\n");
  genAna (freq, anag, len, 0);

  return;
}

/*
Generates the statistics of characters in string s (occurencies) and returns
string length for s.

 */

int
stat (
  char *s,
  int *f
  )
{
  int i, l;

  for (i=0; i<256; i++) {
    f[i]=0;
  }

  for(l=0; s[l]!='\0'; l++) {
    f[s[l]]++;
  }

  return (l);
}


/*
Adds a character in position n in anagram a, taking it from
the pool of available characters in f
 */


void
genAna (
  int *f,
  char *a,
  int l,
  int n
  )
{
  static numeroAnagramma = 1;
  int c;

  if (n >= l) {
    fprintf (stdout, "%d ", numeroAnagramma);
    numeroAnagramma++;

    a[n]='\0';    
    fprintf (stdout, "%s\n", a);
    return;
  }

  for(c=0; c<=255; c++) {
    if(f[c]>0) {  
    /* character available */
    a[n] = c;
    f[c]--;
    genAna (f, a, l, n+1);
    f[c]++;
    }
  }

  return;
}

