/* 
   Author: Sergio Porcu
   
This code finds the biggest number that divides exactly two given numbers,
via recursion and iteration.
*/

#include <stdio.h>

int mcdRic (int a, int b);
int mcdIte (int a, int b);
void swap (int *a, int *b);

main ()
{
  int n, n1, n2;
 
  fprintf (stdout, "First number: ");
  scanf ("%d", &n1);
  fprintf (stdout, "Second number: ");
  scanf ("%d", &n2);

  n = mcdIte (n1, n2);
  fprintf (stdout, "Iterative solution = %d\n", n);

  n = mcdRic (n1, n2);
  fprintf (stdout, "Recursive solution = %d\n", n);

  return;
}


int
mcdIte (
  int a,
  int b
  )
{
  int tmp, r;

  while ( b!=0 ) {
    if (b>a) {
      swap (&a, &b);
    }
    r = a%b;
    a = b;
    b = r;
  }

  return (a);
}

int
mcdRic (
  int a,
  int b
  )
{
  int r;

  if (b>a) {
    swap (&a, &b);
  }

  if (b==0) {
    return (a);
}

  r = a%b;
  return (mcdRic (b, r));
}

void
swap (
  int *a,
  int *b
  )
{
  int tmp;

  tmp = *a; *a = *b; *b = tmp;

  return;
}

